<template>
    <div class="">
            <button @click="call"  class="add-button-mobile ml-2 btn btn-xs btn-secondary text-xs">
                           <i class="fas fa-plus-circle right "></i>
            </button>
            <page-header title="Trombinoscope">
              <span slot="btn">

              </span>
              <div slot="nav" v-if="user.type ==='admin'">
                <div  class=" drowpdown mr-3">
                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-plus-circle mr-3" ></i>Exporter vers
                    </button>
                    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                          <a href="javascript:void(0);"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
                    </div>
                    </div>
              </div>
            </page-header>
             <div class="row">
               <div class="col-md-2">
                 <div :class="['card bg-transparent']" >
                     <div class="card-header card-header-filtre pl-0" style="" >
                             <h3 class="card-title mb-0 hidden-xs d-flex" style="">

                        <i class="fas fa-filter mr-1 ml-1" style="line-height:inherit"></i> Filtres
                        </h3>
                         <div class="card-tools ">
                           <button  title="Retiter tous les filtres" v-if="anyFilter" @click="removeAllFilters" class="btn btn-xs btn-default button-retrait-filtre">
                              <i class="fas fa-times-circle"></i> Retirer les filtres
                           </button>
                         </div>
                     </div>
                 </div>
                 <div class="d-flex flex-column">
                         <div class="form-group ">
                     <label class="">Pays</label>
                      <multi-select class="country "
                            no-ptions="Aucun revendeur disponible" open-direction="bottom"
                            v-model="pays"  :options="_pays"
                            @input="trackPays"
                            :show-labels="false" :searchable="true" :clear-on-select="false"
                            :close-on-select="true"  placeholder="Filtre par pays" label="libelle" track-by="id">
                                <!-- <template slot="singleLabel" slot-scope="props"><img width="20" class="option__image mr-1" :src="'/storage/flags/'+props.option.code2.toLowerCase()+'.png'" :alt="props.option.libelle"><span class="option__desc"><span class="option__title">{{ props.option.libelle }}</span></span>

                                </template> -->
                                <!-- <template slot="option" slot-scope="props">
                                    <img width="20" class="option__image" :src="'/storage/flags/'+props.option.code2.toLowerCase()+'.png'" :alt="props.option.code1">
                                    <div class="option__desc"><span class="option__title">{{ props.option.libelle }}</span></div>
                                </template> -->
                                <span slot="noOptions">
                                    Aucune pays disponible
                                </span>
                                <span slot="noResult">Aucun élement trouvé pour votre recherche</span>
                        </multi-select>
                          </div>
                              <div class="form-group ">
                                                    <label class="">Secteurs d'Activité</label>
                        <multi-select class="" @input="trackSecteurActivite" name="secteur_activite_id"
                                                        v-model="secteur" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Filtre par secteur"
                                                        :options="_secteurs"   label="libelle" track-by="id">

                                                           <span slot="noOptions">
                                                               Aucune secteur d'activité disponible
                                                           </span>
                                                           <span slot="noResult">Aucun élement trouvé pour votre recherche</span>
                        </multi-select>
                        </div>
                                        <div class="form-group ">
                                                    <label class="">Promotions</label>
                                                    <multi-select
                                                        no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                                        name="promotion"
                                                        v-model="moreParams.filter_promotion" :options="_promotions"
                                                        :show-labels="false" :searchable="true" :clear-on-select="false"
                                                        :close-on-select="true"  placeholder="Filtre par promotion"
                                                        >
                                                    </multi-select>
                                        </div>
                 </div>
               </div>

            <div id="bloc" class="col-md-10 bloc">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <h3 class="card-title mb-0 hidden-xs d-flex">
                    <button  @click="call"  class="ml-2 btn  btn-secondary text-xs">
                           <i class="fas fa-plus-circle right "></i>  Nouveau
                        </button>
                    </h3>

                    <div class="card-tools d-flex">
                         <filter-bar ref="filterBar"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <!-- /.card-body -->
               </div>
               <div class="row" v-if="items.length>0">
                 <member-item v-for="(membre,index) in items"   :entity="membre" :key="index"></member-item>

               </div>
               <div class="row" v-else>
                    <p class="text-center w-100 mt-5" v-show="!loading">Aucune donnée disponible
                        <span v-show="hasSearchedOrFilteredData"> pour votre recherche</span>
                     </p>
              </div>
               <div class="swrapper d-flex justify-content-center mt-2 mb-3" v-if="moreExists">
                       <a :class="[loading ? 'btn disabled' : '']" href="javascript:void(0)" @click.prevent="loadMore($event,null)"><span>VOIR
                         <i :class="['fas  mt-1',loading ? 'fa-circle-notch' : 'fa-arrow-down']"></i> PLUS</span></a>
              </div>
              <!-- Modal dbt -->
                  <nouveau-membre @new-member-added="addMember" v-if="visible" @option-fetch-event='getOption'></nouveau-membre>

</div>
 </div>
    </div>
</template>

<script>

   import  Vuetable from "vuetable-2/src/components/Vuetable";
   import pa from './../../components/pagination/Pagination'
   import Form from "./../../classes/Form"
   import Master from "./../Master.vue";
   import MemberItem from "./MemberItem.vue";
   import NouveauMembre from "./NouveauMembre.vue";

   import DocumentInput from "./../../components/DocumentInput"

import { mapGetters } from 'vuex'

    export default {
        mixins: [Master],
        data(){
            return{
                user:window.App.user,
                modeEdit:false,
                ftime:true,
                upadatedTimes:3,
                contentLoaded:false,
                membres :[],
                hasData:false,
                visible:false,
                date_naissance:'',
                maxDate:"",

                moreParams:{filter:"",filter_pays:"",filter_promotion:"",filter_secteur:""},
                isLoading:false,

                //FILTRE
                pays:"",
                secteur:""

            }
        },
        created()
        {
          this.modeEdit = false
          window.event.$emit("isLoading",true)
          this.$store.dispatch('members/init')
          this.$store.dispatch('members/getMembers')
          //this.fetch()
        },
        mounted() {


          this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
          this.$events.$on('filter-reset', e => this.onFilterReset())
          this.visible = true
          var vm = this
           $(window).on('load',function () {

                vm.contentLoaded = true
            });


        },
        computed:
        {
            ...mapGetters({ _pays:"params/_pays",_secteurs:'params/_secteurs',_promotions:"params/_promotions",_civilites:"params/_civilites"
                           ,moreExists:'members/moreExists',next_page_url:"members/next_page_url",total:"members/total"
                           ,current_page:"members/current_page",items:"members/_items",loading:"members/loading",loaded:"members/loaded"}),

            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'un client"  : " Ajout d'un client"
            },
            page_loaded()
            {
              return  this.loaded ;
            },
            anyFilter()
            {
              return this.moreParams.filter_promotion !="" || this.moreParams.filter_pays !="" || this.moreParams.filter_secteur !=""
            },
             hasSearchedOrFilteredData()
            {
              return this.anyFilter || this.moreParams.filter !=""
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false

            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false

            },
            excelUrl()
           {
             return '/clients/export?format=excel&filter='+this.moreParams.filter
           },
           pdfUrl()
           {
             return '/depenses/export?format=pdf&q='+this.searchTxt
           },
        },
        methods:
        {
             loadMore(event,page=null)
             {

                if(page=="null" || page==null)
                page =""

                var p = !isDefined(page) ? this.current_page+1 : page
                var query = "?page="+p
                this.moreParams.query = ""
                for(var propertyName in this.moreParams) {

                    query +="&"+propertyName+"="+this.moreParams[propertyName]

               }

                this.moreParams.query = query;
                query = ""
                this.$store.dispatch('members/getMembers',this.moreParams)


             },
             // Events
             trackSecteurActivite(e)
             {
                 if(e!=null)
                 {
                   this.moreParams.filter_secteur = e.id
                 }
                 else
                 {
                    this.moreParams.filter_secteur = ""
                 }
                 this.loadMore(null,1)

             },
              trackPays(e)
             {
                 if(e!=null)
                 {
                   this.moreParams.filter_pays = e.id
                 }
                 else
                 {
                    this.moreParams.filter_pays = ""
                 }
                 this.loadMore(null,1)
             },
            addMember(membre)
            {
                 this.membres.push(membre)
            },
            removeAllFilters()
            {
                 this.moreParams.filter_promotion=""
                 this.moreParams.filter_pays=""
                 this.moreParams.filter_secteur=""
                 this.secteur=""
                 this.pays=""
                  this.promotion=""
                 this.loadMore(null,1)
            },
              getOption(e)
             {
               //this.options.secteurs = e
             },
                          fetch()
             {
                var url = "/api/membres"



                axios.get(url).then((response) =>
                {

                       this.membres = response.data.data


                       window.event.$emit("isLoading",false)
                       if(this.init==true)
                        {
                          this.init =false
                        }
                        if(this.pageInit==false)
                        {
                            this.pageInit =true
                        }
                        window.scrollTo(0,0)

                },
                (error) => {
                         console.log("Promise Rejected:")

                });
             },
            call()
            {
              window.event.$emit('new-member-event')
            },

            formatDate: function(value, fmt)
            {
               return  toDateFormat(value, fmt)
            },
            onPaginationData (paginationData)
            {
              if(this.pageInit==false)
                 this.pageInit =true
              else
              {

              }
              this.hasData = paginationData.data.length > 0
              this.$refs.pagination.setPaginationData(paginationData)
            },
            onChangePage (page)
            {

               this.$refs.vuetable.changePage(page)
            },
            onLoading()
            {


                    $('table.vuetable').block({
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>',
                        css: { border: 'none' },

                            // styles for the overlay
                            overlayCSS:  {
                                backgroundColor: '#000',
                                opacity:         0.06,
                                cursor:          'wait'
                            },
                    });


            },
            onLoadingDone()
            {
               this.labels()
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },

            onFilterSet (filterText) {
                this.moreParams.filter = filterText
                this.loadMore(null,1)
            },
            onFilterReset () {
                this.moreParams.filter = ""
                Vue.nextTick( () => this.loadMore(null,1))
            },

            //On affiche le modal pour la création
            showModalOnCreate()
            {

                this.modeEdit = false
                this.reset()
                this.$refs['inputModal'].show()

            }

        },
        components:
        {

            Vuetable,
            pa,
            DocumentInput,
            MemberItem,
            NouveauMembre
        },
        updated: function () {
            this.$nextTick(function ()
            {
              if(this.current_page > 1)
              window.scrollTo(0,document.body.scrollHeight);
            })
         },
             watch: {
        page_loaded(newValue) {
           if(newValue == true && this.pageInit == false)
            this.pageInit = true
        },
         loading(newValue) {
               log('oook')
        },
        "moreParams.filter_promotion"(newValue) {
              if(newValue==null)
              this.moreParams.filter_promotion =""
               this.loadMore(null,1)
        }
    }
    }
</script>
<style lang="scss">
.swrapper{
    text-align: center;

a{
  display: block;
  width: 200px;
  height: 40px;
  line-height: 40px;
  font-size: 14px;
  font-family: sans-serif;
  text-decoration: none;
  color: #333;
  border: 2px solid #333;
  letter-spacing: 2px;
  text-align: center;
  position: relative;
  transition: all .35s;
}

a span{
  position: relative;
  z-index: 2;
}

a:after{
  position: absolute;
  content: "";
  top: 0;
  left: 0;
  width: 0;
  height: 100%;
  background: #001f3f;
  transition: all .35s;
}

a:hover{
  color: #fff;
}

a:hover:after{
  width: 100%;
}
}

</style>
